Create, Update, and Delete Activities in the Manual Activity Sheet of a Specific Shell

POST /ws/rest/service/v2/activity/sheet/manualactivities

Available: Version 23.12 and later

Purpose

Create, update, and delete activities in the Manual Activity Sheet of a shell for a project number and the activity sheet name specified in the input parameters.

Activities data passed as part of the Activity API will be created, updated, or removed based on the details below:

  • Create: If the API request has activities for which the Activity ID is not present in the system, the Activity data will be created or added by the API request.
  • Update: If the API request has activities for which the Activity ID is present in the system, the Activity data will be updated by the API request.
  • Remove: In the API request options, if the remove unreferenced data value passes as true, all the activities not present in the API request but present in Unifier will be removed.

Additional Information about P6 Activity Picker

  • • The P6 Activity Picker is supported when creating records through CSV import and RESTful services.
  • • When a P6/Oracle Primavera Cloud project is associated with the System Activity Sheet, the CSV template or the RESTful call accepts the following format for P6 Activity Picker value: <P6/Oracle Primavera Cloud Project ID> ~~ <Activity ID>

Prerequisites

The activity sheet should be manually created in the Activity Sheet sub-node.

To link or associate activities to WBS codes in the request parameters, ensure that the WBS codes are already created in the WBS sheet using the WBS REST API manually or by integration.

Note:

  • The API uses fields added in the Integration form of the Activity Sheet (uDesigner). The fields that have not been added in the integration form will still adhere to the logic defined in the next section for auto-population, but will not be present in the API payload or response.
  • All the request parameter type related validations are applied based on the definitions present in the Detail form (for example, the length of string). Only the Activity ID and Activity Name length checks will be considered as given in the table below.
  • The mandatory elements defined in the Detail form are the mandatory elements in this API. If there are any fields that are not given in the mandatory list below but are still in the Manual Activity Sheet detail form marked as Required, the API will throw an appropriate error if the values are not applicable for those fields.
  • For the Manual Activity Sheet: - All Timestamp (dates) and related fields are considered only in hours. If the request has minutes, it will be ignored. - To avoid time-related discrepancies between the web-based interface and API requests, the system assumes that the time zone for the Activity Sheet is the same as the time zone for the server.
  • All read-only attributes of the Detail form are not considered for updates through the API (though the values are passed in the API request).

In the Read-Only field, the behavior should not be changed in the Detail form as it can create corrupt data:

  • uuu_P6ActualTotalCost
  • uuu_P6ActualTotalUnits
  • uuu_P6PlannedTotalCost
  • uuu_P6PlannedTotalUnits
  • uuu_P6AtCompletionTotalCost
  • uuu_P6AtCompletionTotalUnits
  • uuu_P6AtCompletionDuration
  • uuu_P6RemainingTotalCost
  • uuu_P6RemainingTotalUnits
  • uuu_P6BAC
  • uuu_P6CPIndex
  • uuu_P6CSIndex
  • uuu_P6CostVariance
  • uuu_P6EVCost
  • uuu_P6EACCost
  • uuu_P6ETC
  • uuu_P6SPIndex
  • uuu_P6ScheduleVariance
  • uuu_P6TCPIndex
  • uuu_P6VAC
  • uuu_float
  • uuu_P6PVCost
  • uuu_P6WBSCode
  • uuu_P6WBSName
  • uuu_P6WBSPath
  • uuu_P6PerfPercComplete

Request Parameters

The Request parameters are a JSON Map {} - structure {"options":{}, "data":[] }

For the "options" JSON Map, the following fields and validations are applicable.

Mandatory Fields for "options" JSON Map

The following mandatory fields are applicable to the "options" JSON Map.

Field Name Data Type Description
project_number String A valid 'Active' Unifier shell number (shell number into which the system is going to update project details). For example, "P-0001."
activitySheetName String

The name of the manual Activity Sheet into which activities are inserted, updated, or removed.

If there is no activity sheet present with this name, an error will be thrown. For example, "Activity Sheet 1."

Optional Fields for "options" JSON Map

The following optional fields are applicable to the "options" JSON Map.

Field Name Data Type Description
removeUnreferencedData Boolean

Accepts only true or false.

If this value is true, the activities in the API request will be created and updated. Activities that do not exist in the request data will be removed from the existing activity sheet.

If this value is false, the activities in the API request will not be removed from the existing activity sheet. Activities will be created from the request data if they are not existing or updated if they are existing.

If the attribute does not pass in the request, the default value is considered as false. The activity data that does not exist in the current API request data will not be removed.

Validation Messages and Status Codes for "options" JSON Map

The following messages are displayed for "options" JSON Map.

Use-Case Status Message
project_number not given. 12018 Provide a project number to proceed. The field [project_number] is required.
Invalid project_number 602 Project/Shell Number is not correct.
Inactive project_number 12020 The project number [project_number] is currently inactive, on-hold or view only. Verify its status in Unifier before proceeding.
project_number is empty/blank 12128 The project number field is empty. Enter a valid project number.
If activity sheet name is empty or null 12012 Activity sheet name [activitySheetName] is missing from the request.
Activity Sheet Name exceeded 250 characters. 12017 Invalid value was found in a field: [activitySheetName]. Allowed length: [250]
Activity Sheet Name doesn't exist. 12013 Activity sheet name, [activitySheetName] does not exist as a manual sheet in Unifier. Check if this name has been configured as a manual sheet in Unifier.
Non boolean value provided in removeUnreferencedData 12031

Invalid value was found in a field: [removeUnreferencedData].

Allowed only boolean value.

Mandatory Fields for "data" JSON Map

Apart from the list of mandatory fields below, any fields added as Required in the Activity Sheet, uDesigner, or Detail form are also considered as mandatory by the API, and appropriate error messages will be displayed if the field does not pass for any of the mandatory fields.

Field Name Data Type Description
uuu_P6ActivityId String The ID or Activity code. This is expected to be unique for each activity in the activity sheet. For example, "A1000".
uuu_P6ActivityName String Name of the Activity.
uuu_P6Start Timestamp

If this data element is not provided in the API, throw an error.

If this value is provided in the API, check if uuu_P6Start >= Project Schedule Start Date; otherwise, throw an error. For example, "2022-12-13T08:00:00".

uuu_P6Finish Timestamp

If this data element is not provided in the API, throw an error.

If this value is provided in the API, check if uuu_P6Finish >= uuu_P6Start; otherwise, throw an error.

If Activity Type = Start Milestone

If this value is provided in the API, check if uuu_P6Finish = uuu_P6Start; otherwise, throw an error. For example, "2022-12-15T16:00:00."

uuu_P6Duration Integer

If this data element is not provided in the API, throw an error.

If this value is provided in the API, check if it is double & >=0; otherwise, throw an error.

If this value is provided in the API, check if it is uuu_P6Duration=Finish-Start; otherwise, throw an error.

If this value is not provided in the API, update it as Finish-Start.

Validation Messages and Status Codes for "Data" JSON Map

The following messages are displayed for "Data" JSON Map.

Use-Case Status Message
Activity Id exceeds 120 characters. 12003 Invalid value was found in a field: [uuu_P6ActivityId]. Allowed length: [250]. Activity Id: <Activity Id>
Duplicate Activity ID exists in Sheet. 12001 Invalid value was found in a field: [uuu_P6ActivityId]. This uuu_P6ActivityId already exists. Activity Id: <Activity Id>
If not provided in API 12009 The API request is missing the required information: [uuu_P6ActivityId]. Activity Id: <Activity Id>
Activity Id cannot be blank. 12030 The API request contains an empty value for: [uuu_P6ActivityId].
Activity Name exceeds 250 characters. 12002 Invalid value was found in a field: [uuu_P6ActivityName]. Allowed length: [250]. Activity Id: <Activity Id>
Activity Name Missing in payload. 12004 The API request is missing the required information: [uuu_P6ActivityName].
Activity Name cannot be blank. 12030 The API request contains an empty value for: [uuu_P6ActivityName].
If not provided in the API, throw an error. 12007 The API request is missing required information: [uuu_P6Start]. Activity ID: <activityId>.
Invalid uuu_P6Start format or null or empty value provided in the API Request. 12620 The API request contains an invalid value: [uuu_P6Start]. Correct date format [yyyy-MM-ddTHH:mm:ss]. Activity ID: <activityId>.
uuu_P6Start provided is on holiday or non-working day 12672 Invalid value was found in a field: [uuu_P6Start]. Please provide a working day according to the calendar. Activity ID: <activityId>
If uuu_P6Start < Project Schedule Start Date 12041 Invalid value was found in a field [uuu_P6Start]. The value provided should be greater than or equal to Project Schedule Start Date. Activity ID: <activityId>
Time provided is outside the working hours 12065 Invalid value was found in a field [uuu_P6Start]. Cannot update uuu_P6Start as the time is outside the working hours according to the calendar. Activity ID: <activityId>

Optional Fields that are Validated and Updated

If the following fields are included in the Integration form, they are validated, and the Activity Sheet is updated to reflect changes.

Field Name Data Type Description
uuu_P6PlannedStart Timestamp

The planned start of an activity.

If this value is provided in the API, check if it is in the correct date format; otherwise, throw an error.

If this value is provided in the API, check if the date entered >= Project Schedule Start Date; otherwise, throw an error.

For Status = Not Started

If this value is not provided in the API, default it to P6Start.

If this value is provided in the API, check if P6Start = PlannedStart; otherwise, throw an error. For example, "2022-12-13T08:00:00."

uuu_P6PlannedFinish Timestamp

The planned finish of an activity.

If this value is provided in the API, check if it is in the correct date format; otherwise, throw an error.

If this value is provided in the API, check if the date entered >= Planned Start Date; otherwise, throw an error.

If this value is not provided in the API, default it to P6Finish.

If Status = Not Started

If this value is provided in the API, check if P6Finish = PlannedFinish; otherwise, throw an error.

If Activity Type = Start Milestone

If this value is provided in the API, check if uuu_P6PlannedFinish = uuu_P6PlannedStart; otherwise, throw an error. For example, "2022-12-15T16:00:00."

uuu_P6PlannedDuration Integer

If this value is provided in the API, check if its value is a positive integer; otherwise, display an error.

If this value is provided in the API, check if its uuu_P6PlannedDuration=uuu_P6PlannedFinish -uuu_P6PlannedStart; otherwise, display an error.

If this value is not provided in the API, update it as uuu_P6PlannedFinish -uuu_P6PlannedStart. For example, 10.

Optional Fields that are Validated but Not Updated

If the following fields are included in the Integration form, they are validated. However, the Activity Sheet is not updated to reflect changes.

Field Name Data Type Description
uuu_P6ActivityCalendar String

If this value is not provided in the API, it will be populated with the default value defined in the Activity Sheet properties.

If the calendar is explicitly specified in the API, validate that the calendar name exists as custom calendars or company calendars. For example, "Company Calendar".

uuu_P6ActivityStatus String

If this value is provided in the API, check for the actual start value and proceed with updating accordingly.

If this value is not provided in the API, it will be considered as "Not Started." New activities and the current status will be considered for existing activities.

If Activity Type = Start Milestone

If uuu_P6ActualStart or uuu_P6ActualFinish is provided and uuu_P6ActivityStatus is not provided, the status will be considered as Completed.

If uuu_P6ActualStart or uuu_P6ActualFinish is provided and uuu_P6ActivityStatus != Completed then throw an error.

If uuu_P6ActualStart and uuu_P6ActualFinish is empty or not provided and uuu_P6ActivityStatus != Not Started, throw an error.

uuu_P6ActualStart Timestamp

If uuu_P6ActivityStatus =In Progress OR Completed

This will be updated from the API Request without any changes to uuu_P6ActivityStatus.

If uuu_P6ActivityStatus = Not Started

If it is not provided in the API request, uuu_P6ActivityStatus will remain "Not Started."

If it is provided in the API request and the uuu_P6ActualFinish is not provided, the uuu_P6ActivityStatus will be updated to "In Progress."

If it is provided in the API request, the uuu_P6ActualFinish is not provided and the uuu_P6ActivityStatus is provided in the API but is not equal to In Progress or Completed, throw an error. For example, "2022-12-13T16:00:00."

uuu_P6ActualFinish Timestamp

If uuu_P6ActivityStatus = Not Started OR In Progress

If it is provided in the API request, the uuu_P6ActivityStatus will be updated to "Completed."

If it is provided in the API request, and the uuu_P6ActivityStatus is also provided in the API but is not equal to Completed, throw an error.

If Activity Type = Start Milestone

If uuu_P6ActivityStatus = completed and this value is provided in the API, check if uuu_P6ActualFinish = uuu_P6ActualStart; otherwise, throw an error. For example, "2022-12-13T16:00:00."

uuu_P6RemainingEarlyStart Timestamp

If this value is provided in the API, check if it is in the correct date format; otherwise, throw an error.

If this value is provided in the API, check if date entered >= Project Schedule Start Date; otherwise, throw an error.

For uuu_P6ActivityStatus = Not Started

If this value is not provided in the API then default it to P6Start.

For uuu_P6ActivityStatus = Completed

If this value is provided in the API, throw an error. For example, "2022-12-13T08:00:00."

uuu_P6RemainingEarlyFinish Timestamp

If this value is provided in the API, check if it is in correct date format; otherwise, throw an error.

If this value is provided in the API, check if the date entered >= Remaining Start Date; otherwise, throw an error.

If this value is not provided in the API, default it to P6Finish.

For uuu_P6ActivityStatus = Completed

If this value is provided in the API, throw an error. For example, "2022-12-15T16:00:00."

uuu_P6RemainingDuration Integer

If this value is provided in the API, check if it is a positive integer value; otherwise, throw an error.

If this value is provided in the API, check if it is uuu_P6RemainingDuration=uuu_P6RemainingEarlyFinish-uuu_P6RemainingEarlyStart; otherwise, throw an error.

If this value is not provided in the API, update it as Finish-Start.

For uuu_P6ActivityStatus = Completed

If this value is provided in the API, throw an error. For example, 10.

uuu_activity_constraint_type String

If this value is provided in the API, check if it is [As soon as possible]; otherwise, throw an error.

If this value is not provided in the API, update it as "As soon as possible."

uuu_duration_type String

If this value is provided in the API, check if it is [Fixed Duration, Fixed Units, Fixed units/time]; otherwise, throw an error.

If this value is not provided in the API, update it as "Fixed Duration."

uuu_P6ActivityType String

If this value is provided in the API, check whether it is [Task Dependent, Start Milestone]. If not, throw an error.

When uuu_P6ActivityType is updated to Start Milestone, the system automatically deletes existing assignments for that activity as part of the update.

If this value is not provided in the API, it will be populated with the value - Task Dependent.

If the uuu_P6ActivityType value is provided in the API as Task Dependent and uuu_P6Duration is 0, throw an error.

bItemID String

This can be updated from the API Request.

The full path of the CBS Code with the entire hierarchy present in the Cost Sheet has to be given, otherwise it will throw an error. "~~" will be used as path separators for the hierarchy.

If an Inactive costCode is provided in the request, the system checks for the following:

If it creates a new activity, the system will throw an error related to inactive costCode.

If it is an update of the activity, the system will compare the existing costCode for that activity. If it is same as the existing one, the system will not throw an error. Instead, the system will skip the update of the costCode. But, if it is not same as the existing costCode, the system will throw an error related to the inactive costCode. For example, "C-001~~C-0011."

uuu_cmwbs_picker String

This can be updated from the API Request.

If the WBS Sheet does not exist in the shell, throw an error.

If the WBS code does not exist in the WBS Sheet throw an error.

For example, "P-001.WBS1."

uuu_P6PercentComplete Integer

This can be updated in the API Request.

For uuu_P6ActivityStatus = Not Started

This value should be zero. If the value is provided in the API Request and the value is not zero, throw an error.

For uuu_P6ActivityStatus = In Progress

If this value is provided in the API, it should be in the range of [0-100].

For uuu_P6ActivityStatus = Completed

This value should be 100. If the value is provided in the API Request and it is not equal to 100, throw error. For example, 50.

Validation Messages and Status Codes for "Data" JSON Map

The following messages are displayed for "Data" JSON Map.

Use-case Status Message
Invalid uuu_P6ActivityCalendar value provided (Non-String) or null or empty value provided in the API Request. 12045 Invalid value was found in a field [uuu_P6ActivityCalendar]. Allowed only string values. Activity ID: <activityId>
Calendar not configured in the Unifier Shell/Project 12046 Invalid value was found in a field [uuu_P6ActivityCalendar]. Allowed only Calendars configured in the respective Unifier Project/Shell. Activity ID: <activityId>
Invalid value or format or null or empty value provided in the API Request 12042 Invalid value was found in a field [uuu_P6ActivityStatus]. Allowed values: [Not Started, In Progress, Completed]. Activity ID: <activityId>
If uuu_P6ActualStart is provided and uuu_P6ActivityStatus is provided as Not Started. 12051 Invalid value was found in a field: [uuu_P6ActivityStatus]. Cannot update uuu_P6ActivityStatus to Not Started, if uuu_P6ActualStart is not empty. Activity ID: <activityId>
If uuu_P6ActualFinish is provided and uuu_P6ActivityStatus is provided as "In Progress". 12051 Invalid value was found in a field: [uuu_P6ActivityStatus]. Cannot update uuu_P6ActivityStatus to In Progress, if uuu_P6ActualFinish is not empty. Activity ID: <activityId>
If uuu_P6ActualStart is empty or not provided in the API and Status is equal to In Progress or Completed 12052 Invalid value was found in a field: [uuu_P6ActivityStatus]. Cannot update uuu_P6ActivityStatus to In Progress or Completed, if uuu_P6ActualStart is empty. Activity ID: <activityId>
If uuu_P6ActualFinish is empty or not provided in the API and Status is equal to Completed 12053 Invalid value was found in a field: [uuu_P6ActivityStatus]. Cannot update uuu_P6ActivityStatus to Completed, if uuu_P6ActualFinish is empty. Activity ID: <activityId>
If uuu_P6ActivityType = Start Milestone, and If uuu_P6ActualStart or uuu_P6ActualFinish is provided and uuu_P6ActivityStatus != Completed 12063 Invalid value was found in a field [uuu_P6ActivityStatus]. Cannot update uuu_P6ActivityStatus to Not Started or In Progress, if uuu_P6ActivityType = Start Milestone and either uuu_P6ActualStart or uuu_P6ActualFinish is not empty. Activity ID: <activityId>
If uuu_P6ActivityType = Start Milestone, and If uuu_P6ActualStart and uuu_P6ActualFinish are empty and uuu_P6ActivityStatus != Not Started 12062 Invalid value was found in a field [uuu_P6ActivityStatus]. Cannot update uuu_P6ActivityStatus to In Progress or Completed, if uuu_P6ActivityType = Start Milestone and uuu_P6ActualStart or uuu_P6ActualFinish are empty. Activity ID: <activityId>
Invalid uuu_P6PlannedStart format or null or empty value provided in the API Request. 12620 The API request contains an invalid value: [uuu_P6PlannedStart]. Correct date format [yyyy-MM-ddTHH:mm:ss]. Activity ID: <activityId>.
uuu_P6PlannedStart provided is on holiday or non-working day 12672 Invalid value was found in a field: [uuu_P6PlannedStart]. Please provide a working day according to the calendar. Activity ID: <activityId>
If uuu_P6PlannedStart < Project Schedule Start Date 12041 Invalid value was found in a field [uuu_P6PlannedStart]. The value provided should be greater than or equal to Project Schedule Start Date. Activity ID: <activityId>
Time provided is outside the working hours 12065 Invalid value was found in a field [uuu_P6PlannedStart]. Cannot update uuu_P6PlannedStart as the time is outside the working hours according to the calendar. Activity ID: <activityId>
Invalid uuu_P6PlannedFinish format or null or empty value provided in the API Request. 12620 The API request contains an invalid value: [uuu_P6PlannedFinish]. Correct date format [yyyy-MM-ddTHH:mm:ss]. Activity ID: <activityId>.
uuu_P6PlannedFinish provided is on holiday or non-working day 12672 Invalid value was found in a field [uuu_P6PlannedFinish]. Please provide a working day according to the calendar. Activity ID: <activityId>
If uuu_P6PlannedFinish < uuu_P6PlannedStart 12038 Invalid value was found in a field [uuu_P6PlannedFinish]. The value provided should be greater than or equal to uuu_P6PlannedStart. Activity ID: <activityId>
If uuu_P6ActivityType = Start Milestone, and if uuu_P6PlannedFinish != uuu_P6PlannedStart 12061 Invalid value was found in a field [uuu_P6PlannedFinish]. The value provided should be equal to uuu_P6PlannedStart, if uuu_P6ActivityType = Start Milestone. Activity ID: <activityId>
Time provided is outside the working hours 12065 Invalid value was found in a field [uuu_P6PlannedFinish]. Cannot update uuu_P6PlannedFinish as the time is outside the working hours according to the calendar. Activity ID: <activityId>
If uuu_P6PlannedDuration value provided is null 12047 Invalid value was found in a field [uuu_P6PlannedDuration]. Activity ID: <activityId>
Invalid uuu_P6PlannedDuration(Not Integer) or empty 12616 Invalid value was found in a field [uuu_P6PlannedDuration]. Allowed only positive decimal value. Activity ID: <activityId>
Invalid uuu_P6ActualStart format or null or empty value provided in the API Request 12620 The API request contains an invalid value: [uuu_P6ActualStart]. Correct date format [yyyy-MM-ddTHH:MM:SS]. Activity ID: <activityId>
If uuu_P6ActualStart provided is on holiday or non-working day 12672 Invalid value was found in a field: [uuu_P6ActualStart]. Please provide a working day according to the calendar. Activity ID: <activityId>
If uuu_P6ActualStart < Project Schedule Start Date 12041 Invalid value was found in a field [uuu_P6ActualStart]. The value provided should be greater than or equal to Project Schedule Start Date. Activity ID: <activityId>
If Activity Status = In Progress and uuu_P6ActualStart != P6Start 12048 Invalid value was found in a field [uuu_P6ActualStart]. The value provided should be equal to uuu_P6Start, if uuu_P6ActivityStatus = In Progress. Activity ID: <activityId>
If Activity Status = Completed and uuu_P6ActualStart != P6Start 12050 Invalid value was found in a field [uuu_P6ActualStart]. The value provided should be equal to uuu_P6Start, if uuu_P6ActivityStatus = Completed. Activity ID: <activityId>
If uuu_P6ActualStart > Today's date 12055 Invalid value was found in a field [uuu_P6ActualStart]. The value cannot be later than today. Activity ID: <activityId>
Time provided is outside the working hours 12065 Invalid value was found in a field [uuu_P6ActualStart]. Cannot update uuu_P6ActualStart as the time is outside the working hours according to the calendar. Activity ID: <activityId>
Invalid uuu_P6ActualFinish format or null or empty value provided in the API Request. 12620 The API request contains an invalid value: [uuu_P6ActualFinish]. Correct date format [yyyy-MM-ddTHH:MM:SS]. Activity ID: <activityId>
If uuu_P6ActualFinish is provided is on holiday or non-working day 12672 Invalid value was found in a field [uuu_P6ActualFinish]. Please provide a working day according to the calendar. Activity ID: <activityId>
If uuu_P6ActualFinish < uuu_P6ActualStart 12038 Invalid value was found in a field [uuu_P6ActualFinish]. The value provided should be greater than or equal to uuu_P6ActualStart. Activity ID: <activityId>
If Activity Status = Completed and uuu_P6ActualStart != P6Start 12050 Invalid value was found in a field [uuu_P6ActualFinish]. The value provided should be equal to uuu_P6Finish, if uuu_P6ActivityStatus = Completed. Activity ID: <activityId>
If uuu_P6ActualFinish > Today's date 12055 Invalid value was found in a field [uuu_P6ActualFinish]. The value cannot be later than today. Activity ID: <activityId>
If uuu_P6ActivityType = Start Milestone, and if uuu_P6ActualFinish != uuu_P6ActualStart 12061 Invalid value was found in a field [uuu_P6ActualFinish]. The value provided should be equal to uuu_P6ActualStart , if uuu_P6ActivityType = Start Milestone. Activity ID: <activityId>
Time provided is outside the working hours 12065 Invalid value was found in a field [uuu_P6ActualFinish]. Cannot update uuu_P6ActualFinish as the time is outside the working hours according to the calendar. Activity ID: <activityId>
Invalid uuu_P6RemainingEarlyStart format or null or empty value provided in the API Request. 12620 The API request contains an invalid value: [uuu_P6RemainingEarlyStart]. Correct date format [yyyy-MM-ddTHH:mm:ss]. Activity ID: <activityId>.
uuu_P6RemainingEarlyStart provided is on holiday or non-working day 12672 Invalid value was found in a field: [uuu_P6RemainingEarlyStart]. Please provide a working day according to the calendar. Activity ID: <activityId>
If uuu_P6RemainingEarlyStart < Project Schedule Start Date 12041 Invalid value was found in a field [uuu_P6RemainingEarlyStart]. The value provided should be greater than or equal to Project Schedule Start Date. Activity ID: <activityId>
If value provided in the API Request for Activity Status=Completed 12040 Invalid value was found in a field [uuu_P6RemainingEarlyStart]. Cannot update uuu_P6RemainingEarlyStart if uuu_P6ActivityStatus = Completed. Activity ID: <activityId>
If Activity Status = Not Started & P6Start != uuu_P6RemainingEarlyStart 12039 Invalid value was found in a field [uuu_P6RemainingEarlyStart ]. The value provided should be equal to uuu_P6Start, if uuu_P6ActivityStatus = Not Started. Activity ID: <activityId>
Time provided is outside the working hours 12065 Invalid value was found in a field [uuu_P6RemainingEarlyStart ]. Cannot update uuu_P6RemainingEarlyStart as the time is outside the working hours according to the calendar. Activity ID: <activityId>
Invalid uuu_P6RemainingEarlyFinish format or null or empty value provided in the API Request. 12620 The API request contains an invalid value: [uuu_P6RemainingEarlyFinish]. Correct date format [yyyy-MM-ddTHH:mm:ss]. Activity ID: <activityId>.
uuu_P6RemainingEarlyFinish provided is on holiday or non-working day 12672 Invalid value was found in a field: [uuu_P6RemainingEarlyFinish]. Please provide a working day according to the calendar. Activity ID: <activityId>
If uuu_P6RemainingEarlyFinish < uuu_P6RemainingEarlyStart 12038 Invalid value was found in a field [uuu_P6RemainingEarlyFinish]. The value provided should be greater than or equal to uuu_P6RemainingEarlyStart. Activity ID: <activityId>
If value provided in the API Request for Activity Status=Completed 12040 Invalid value was found in a field [uuu_P6RemainingEarlyFinish]. Cannot update uuu_P6RemainingEarlyFinish if uuu_P6ActivityStatus = Completed. Activity ID: <activityId>
If Activity Status = Not Started & P6Finish != uuu_P6RemainingEarlyFinish 12039 Invalid value was found in a field [uuu_P6RemainingEarlyFinish]. The value provided should be equal to uuu_P6Finish, if uuu_P6ActivityStatus = Not Started. Activity ID: <activityId>
Time provided is outside the working hours 12065 Invalid value was found in a field [uuu_P6RemainingEarlyFinish]. Cannot update uuu_P6RemainingEarlyFinish as the time is outside the working hours according to the calendar. Activity ID: <activityId>
If uuu_P6RemainingDuration value provided is null 12047 Invalid value was found in a field [uuu_P6RemainingDuration]. Activity ID: <activityId>
Invalid uuu_P6RemainingDuration(Not Integer) or empty 12616 Invalid value was found in a field: [uuu_P6RemainingDuration]. Allowed only positive decimal value. Activity ID: <activityId>
Nonzero value provided in the API Request for Activity Status=Completed 12040 Invalid value was found in a field [uuu_P6RemainingDuration]. Cannot update uuu_P6RemainingDuration, if uuu_P6ActivityStatus = Completed. Activity ID: <activityId>
Invalid uuu_activity_constraint_type value provided (Non-String) or null or empty value provided in the API Request. 12043 Invalid value was found in a field [uuu_activity_constraint_type]. Allowed values: [As soon as possible]. Activity ID: <activityId>
Invalid uuu_duration_type value provided (Non-String) or null or empty value provided in the API Request. 12054 Invalid value was found in a field [uuu_duration_type]. Allowed values: [Fixed Duration, Fixed Units, Fixed units/time]. Activity ID: <activityId>
Invalid uuu_P6ActivityType value provided (Non-String) or null or empty value provided in the API Request. 12044 Invalid value was found in a field [uuu_P6ActivityType]. Allowed values: [Task Dependent, Start Milestone]. Activity ID: <activityId>
If uuu_P6ActivityType value is provided as 'Start Milestone' and Assignments are existing 12064 Invalid value was found in a field [uuu_P6ActivityType]. Cannot update uuu_P6ActivityType to Start Milestone, if the activity has assigned resources. Activity ID: <activityId>
If uuu_P6ActivityType value is Task Dependent and uuu_P6Duration is 0, throw error 12066 Invalid value was found in a field [uuu_P6ActivityType]. Cannot update uuu_P6ActivityType to Task Dependent, if the uuu_P6Duration is 0. Activity ID: <activityId>
Invalid costCode provided - (Non-String) or empty or null or blank 12609 Invalid value was found in a field: [costCode]. Allowed only string values. Activity ID: <activityId>
costCode not existing in Cost Sheet 12610 Invalid value was found in a field [costCode]. Allowed only the Cost codes present in Cost Sheet. Activity ID: <activityId>
Inactive costCode provided in the API request 12623 Invalid value was found in a field: [costCode]. Allowed only active Cost codes. Activity ID: <activityId>
Invalid WBS Code provided - (Non-String) or empty or null or blank 12056 Invalid value was found in a field: [uuu_cmwbs_picker]. Allowed only string values. Activity ID: <activityId>
WBS Code not existing in WBS Sheet or WBS Sheet is not existing 12057 Invalid value was found in a field [uuu_cmwbs_picker]. Allowed only the WBS codes present in WBS Sheet. Activity ID: <activityId>
If uuu_P6PercentComplete value provided is null 12047 Invalid value was found in a field [uuu_P6PercentComplete]. Activity ID: <activityId>
Invalid uuu_P6PercentComplete (Not Integer or Not Double) or empty 12616 Invalid value was found in a field: [uuu_P6PercentComplete]. Allowed only positive integer value. Activity ID: <activityId>
uuu_P6PercentComplete is less than zero or exceeds 100 12058 Invalid value was found in a field: [uuu_P6PercentComplete]. Allowed Range [0-100]. Activity ID: <activityId>
Nonzero value provided in the API Request for uuu_P6ActivityStatus =Not Started 12059 Invalid value was found in a field [uuu_P6PercentComplete]. Value provided should be 0, if uuu_P6ActivityStatus = Not Started. Activity ID: <activityId>
If uuu_P6ActivityStatus = In Progress and uuu_P6PercentComplete is equal to 100 12067 Invalid value was found in a field [uuu_P6PercentComplete]. Value provided cannot be 100, if uuu_P6ActivityStatus = In Progress. Activity ID: <activityId>
If uuu_P6ActivityStatus = Completed and uuu_P6PercentComplete not equal to 100 12060 Invalid value was found in a field [uuu_P6PercentComplete]. Value provided should be 100, if uuu_P6ActivityStatus = Completed. Activity ID: <activityId>

Input Request Data Validations

For Input Request data validations which are not included in the request parameters section are listed below.

Scenario Status Message
If any of the mandatory elements, referencing uDesigner -> Activity Sheet Detail form, is missing. 12027 Mandatory fields are missing: {field name}.
If any of the mandatory elements, referencing uDesigner -> Activity Sheet Detail form, is empty. 12029 Empty value for mandatory field: {field name}.

Sample Response Format

JSON Map {

"status" : <integer value> ,

"data" : [ ] ,

"messages": [ <list of string>] ,

"rest_audit_id": <id from the rest audit table matching this request>

}

where

  • "status" is of Integer data type
  • "data" is a List of Maps data type
  • "messages" is a list if String data type
  • "rest_audit_id" is of integer data type

Sample Request

The following Sample Request is based on the Integration form designed in the respective environment. As mentioned above, integration form fields derive requests and responses in this API.

{

"options":{

"project_number":"P-0115",

"removeUnreferencedData": true,

"activitySheetName":"testSheet"

},

"data":[

{

"uuu_P6ActivityId": "A1000",

"uuu_P6ActivityName": "act0123345",

"uuu_P6Start": "2023-11-02T08:00:00",

"uuu_P6Finish": "2023-11-02T10:00:00",

"uuu_P6ActivityType": "Task Dependent",

"uuu_P6ActivityStatus": "Not Started",

"uuu_activity_constraint_type": "As Soon As Possible",

"uuu_duration_type": "Fixed Duration",

"uuu_P6ActivityCalendar": "Project/Shell Calendar",

"uuu_cmwbs_picker": "P-0115.WBSCODE10",

"uuu_P6Duration": 2.0,

"uuu_P6PlannedDuration":2.0,

"uuu_P6WBSCode": "AV1",

"bItemID": "01000~~01100",

"CheckPullDown": "No",

"uuu_P6ETCComputeType":"1/(BAC-EV)",

},

{

"uuu_P6ActivityId": "A1010",

"uuu_P6ActivityName": "act0123345",

"uuu_P6Start": "2023-11-02T08:00:00",

"uuu_P6Finish": "2023-11-02T10:00:00",

"uuu_P6ActivityType": "Task Dependent",

"uuu_P6ActivityStatus": "Not Started",

"uuu_activity_constraint_type": "As Soon As Possible",

"uuu_duration_type": "Fixed Duration",

"uuu_cmwbs_picker": "P-0115.WBSCODE1",

"uuu_P6Duration": 2.0,

"uuu_P6PlannedDuration":2.0,

"uuu_P6WBSCode": "AV1",

"bItemID": "01000~~01100",

"CheckPullDown": "No",

"uuu_P6ETCComputeType":"1/(BAC-EV)",

}

]

}

Sample Success Response

A Sample Response from the API is listed below. The response returns the database ID of the Activities created newly in the activity table in addition to the activity data that is created or updated.

{

"data": [

{

"uuu_P6Duration": 2.0,

"id": 1482868,

"uuu_P6EVCost": 0.0,

"uuu_P6PlannedTotalCost": 0.0,

"uuu_P6ActivityType": "Task Dependent",

"uuu_P6ActivityId": "A1000",

"CheckPullDown": "No",

"uuu_P6WBSCode": "WBSCODE10",

"uuu_P6RemainingTotalCost": 0.0,

"bItemID": "01000~~01100",

"uuu_P6ActivityStatus": "Not Started",

"uuu_P6PlannedDuration": 2.0,

"uuu_cmwbs_picker": "P-0115.WBSCODE10",

"uuu_P6Finish": "2023-11-02T10:00:00",

"uuu_P6WBSPath": "P-0115.WBSCODE10",

"uuu_P6ActivityCalendar": "Project/Shell Calendar",

"uuu_P6ActivityName": "act0123345",

"uuu_P6ETCComputeType": "Remaining Cost for Activity",

"uuu_P6AtCompletionDuration": 2.0,

"uuu_P6ActualTotalCost": 0.0,

"uuu_P6Start": "2023-11-02T08:00:00"

},

{

"uuu_P6Duration": 2.0,

"id": 1482869,

"uuu_P6EVCost": 0.0,

"uuu_P6PlannedTotalCost": 0.0,

"uuu_P6ActivityType": "Task Dependent",

"uuu_P6ActivityId": "A1010",

"CheckPullDown": "No",

"uuu_P6WBSCode": "WBSCODE1",

"uuu_P6RemainingTotalCost": 0.0,

"bItemID": "01000~~01100",

"uuu_P6ActivityStatus": "Not Started",

"uuu_P6PlannedDuration": 2.0,

"uuu_cmwbs_picker": "P-0115.WBSCODE1",

"uuu_P6Finish": "2023-11-02T10:00:00",

"uuu_P6WBSPath": "P-0115.WBSCODE1",

"uuu_P6ActivityName": "act0123345",

"uuu_P6ETCComputeType": "Remaining Cost for Activity",

"uuu_P6AtCompletionDuration": 2.0,

"uuu_P6ActualTotalCost": 0.0,

"uuu_P6Start": "2023-11-02T08:00:00"

}

],

"message": [

"success"

],

"status": 200,

"rest_audit_id": 20581

}